/////////////////////////////////////////////////////////////
//
// Unit NkClipDetector  --- Clipborad Change Detector
//
// Coded By T.Nakamura
//
//
//  
//
//  Ver 1.0   Apr. 27 '97 
//  Ver 1.1   Apr. 28 '97 IgnoreFirst Property ǉB
//  Ver 1.2   May.  8 '97 sɃCxgnhuύXvłȂA
//            ƂoOCB
//



unit NkClipDetector;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TNkClipDetector = class(TComponent)
  private
    hNextClipViewer: THandle;     //  Viewer ̃nh
    FOnClipChange: TNotifyEvent;  // OnClipChange ̃nh
    SettingViewer: Boolean;        // Viewer Zbg
    FIgnoreFirst: Boolean;        // IgnoreFirst Property
    hWnd: THandle;                // ClipBoard Viewer ̃nh

    procedure SetOnClipChange(Value: TNotifyEvent);
    procedure ClipMessageProc(var Msg: TMessage);
  protected
    procedure ClipChange; virtual; // OnClipChange N
                                   // CxgfBXpb`
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;

  published
    property IgnoreFirst: Boolean read FIgnoreFirst
                                  write FIgnoreFirst
                                  default True;
    property OnClipChange: TNotifyEvent read FOnClipChange
                                        write SetOnClipChange;
  end;

procedure Register;

implementation

constructor TNkClipDetector.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FIgnoreFirst := True;
end;

destructor TNkClipDetector.Destroy;
begin
  if hWnd <> 0 then begin
    // ClipBoard Viewer LΔj
    ChangeClipBoardChain(hWnd, hNextClipViewer);
    DeallocateHwnd(hWnd);
  end;
  inherited Destroy;
end;

procedure TNkClipDetector.SetOnClipChange(Value: TNotifyEvent);
begin
  if (csDesigning in ComponentState) then begin
    // ݌vɂ̓nh̃\bh|C^邾B
    // ȂƃtH[t@CɃnhZ[uȂB
    FOnClipChange := Value
  end
  else begin
    // nh̃|C^ Nil  ClipBoard Viewer ꍇ
    // ClipBoard Viewer jB
    if not Assigned(Value) then begin
      if hWnd <> 0 then begin
        ChangeClipBoardChain(hWnd, hNextClipViewer);
        DeallocateHwnd(hWnd);
        hWnd := 0;
        FOnClipChange := Nil;
      end;
    end
    else begin
      // nh̃|C^ Nil łȂꍇ
      if hWnd = 0 then begin  // nh̓o^
        // Viwer ̂ōēo^
        hWnd := AllocateHwnd(ClipMessageProc);
        if hWnd = 0 then raise EOutOfResources.Create(
           'TNkClipDetector.SetOnClipChange: Cannot Allocate HWnd');
        FOnClipChange := Value;
        SettingViewer := True;
        hNextClipViewer := SetClipboardViewer(hWnd);
        SettingViewer := False;
      end
      else  // nh̕ύX
        // Viewer 쐬ς݂ȂACxgnhύX邾B
        FOnClipChange := Value;
    end;
  end;
end;


// ClipBoard Viwer ̃bZ[W
procedure TNkClipDetector.ClipMessageProc(var Msg: TMessage);
begin
  case Msg.Msg of
  WM_DRAWCLIPBOARD: begin  // `v
    if (not IgnoreFirst) or (not SettingViewer) then
      ClipChange;            // CxgnhĂ
    //  Clipboard Viewer ɃbZ[WnB
    if hNextClipViewer <> 0 then
      SendMessage(hNextClipViewer, WM_DRAWCLIPBOARD, 0, 0);
  end;
  WM_CHANGECBCHAIN: begin
    if msg.wParam = hNextClipViewer then begin
      // ̎ Clipboard Viewer  폜ꂽꍇ
      hNextClipViewer := msg.lParam;
      msg.Result := 0; // ς݂ɂBdvII
    end
    else begin
      //  Clipboard Viewer ɃbZ[WnB
      Msg.Result := SendMessage(hNextClipViewer, WM_CHANGECBCHAIN,
                                Msg.wParam, Msg.lParam);
    end;
  end;
  else
    // Default  Message 
    Msg.Result := DefWindowProc(hWnd, Msg.Msg, Msg.wParam, Msg.LParam);
  end;
end;

// CxgfBXpb`
procedure TNkClipDetector.ClipChange;
begin
  if Assigned(FOnClipChange) then FOnCLipChange(Self);
end;


procedure Register;
begin
  RegisterComponents('Samples', [TNkClipDetector]);
end;

end.
